#ifndef AUTODOCS_H
#define AUTODOCS_H

#ifndef MAIN_H
#include "main.h"
#endif

#ifndef FILE_H
#include "File.h"
#endif

/************************************************************************/

struct AutodocFileNode
  {
    struct AnyNode AnyNode;	/* name is filename ("exec.doc") */
    char *LinkName;
    struct AutodocModuleNode *Modules;	/* linked list of modules in file */
  };

extern struct AVLTree AutodocFileTree;

/************************************************************************/

struct AutodocModuleNode
  {
    struct AnyNode AnyNode;	/* name is the module name ("exec.library") */
    struct AutodocFileNode *AutodocFileNode;
    struct AVLTree Nodes;	/* tree of AutodocNodeNodes */
    struct AutodocInfoNode *InfoNodes;	/* linked list of --information-- nodes */
    struct AutodocModuleNode *Next;	/* linked list of modules in file */
  };

extern struct AVLTree AutodocModuleTree;

/************************************************************************/

struct AutodocNodeNode
  {
    struct AnyNode AnyNode;	/* name is unqualified node name ("AllocMem") */
    struct AutodocModuleNode *AutodocModuleNode;
    struct AutodocNode *AutodocNode;
    struct AutodocNodeNode *Next;
    struct AutodocNodeNode *RealNode;	/* points to the real node (if this is a varargs stub) */
    /* points to itself if this is a real node */
    int Found;			/* really found a node */
  };

/************************************************************************/

struct AutodocInfoNode
  {
    struct AutodocInfoNode *Next;	/* linked list of --information-- nodes */
    char *Name;			/* name ("background") */
    int Found;			/* really found a node */
  };

/************************************************************************/

struct AutodocNode
  {
    struct AnyNode AnyNode;
    struct AutodocNodeNode *Entries;
    int Function;		/* TRUE=function, FALSE=define */
  };

extern struct AVLTree AutodocNodeTree;

/************************************************************************/

void ConvertNodeText (int, void *);
int DoAutodoc (struct Word *, struct AutodocNodeNode *);

void ProcessAutodocFile1 (char *);
void ProcessAutodocFile2 (struct AutodocFileNode *);

/************************************************************************/

#endif /* AUTODOCS_H */
